#Main file
#Coding based on and inspired by model made by Risvan Dirza(NTNU).
#Integrates the system of equations with the use of the CasADI framework IDAS integrator.
#Optimize the system of equations with the use of the CasADI framework IPOPT nlp solver.


import numpy as np
from sys import path
path.append(r"C:/Users/Bruker/Documents/CASADIPython/casadi-windows-py38-v3.5.5-64bit")
from casadi import *
import casadi as ca

# Call the parameters
import ParamFordelivery

#par now represents the dictionary defined in parameter function
par = ParamFordelivery.Params_6wells()




import pandas as pd
#Retrieve initial guesses for the differential states(x0), algebraic states(z0) and
#controlled variables(u0). Data listed in excel, comma separated files.
x0 = pd.read_csv('Data Folder 6wellsSeptestCompGL32/x06Sep.csv',header=None).values.reshape(-1)
z0 = pd.read_csv('Data Folder 6wellsSeptestCompGL32/z06Sep.csv',header=None).values.reshape(-1)
u0 = pd.read_csv('Data Folder 6wellsSeptestCompGL32/u06Sep.csv',header=None).values.reshape(-1)

#Retrieve the lower and upper bounds for the differential states(x), algebraic states(z) and
#controlled variables(u). Data listed in excel, comma separated files.
lbx = pd.read_csv('Data Folder 6wellsSeptestCompGL32/lbx6Sep.csv',header=None).values.reshape(-1)
lbz = pd.read_csv('Data Folder 6wellsSeptestCompGL32/lbz6Sep.csv',header=None).values.reshape(-1)
lbu = pd.read_csv('Data Folder 6wellsSeptestCompGL32/lbu6Sep.csv',header=None).values.reshape(-1)
ubx = pd.read_csv('Data Folder 6wellsSeptestCompGL32/ubx6Sep.csv',header=None).values.reshape(-1)
ubz = pd.read_csv('Data Folder 6wellsSeptestCompGL32/ubz6Sep.csv',header=None).values.reshape(-1)
ubu = pd.read_csv('Data Folder 6wellsSeptestCompGL32/ubu6Sep.csv',header=None).values.reshape(-1)

#Define the parameter intial values(constant, if not manually changed)
p0 = ca.vertcat(par['GOR'],par['wmax_gl'],par['wmax_pg'],par['Powmax_glcom'],par['p_go'],par['p_oo']) 

#Call the simulator
import SimulatorFordelivery

#Retrieve return variables of the integrator function
F,x_var, z_var, u_var, p_var, alg, dif, L, g_var =  SimulatorFordelivery.CentralizedSimulator_F(par)
"""
###For plotting of integration results ####
t_span = np.arange(10000)
#x-values containers

m_ga1plot = []
m_ga2plot = []
m_ga3plot = []
m_ga4plot = []
m_ga5plot = []
m_ga6plot = []
m_gt1plot = []
m_gt2plot = []
m_gt3plot = []
m_gt4plot = []
m_gt5plot = []
m_gt6plot = []
m_ot1plot = []
m_ot2plot = []
m_ot3plot = []
m_ot4plot = []
m_ot5plot = []
m_ot6plot = []
m_grplot = []
m_orplot = []
p_gsplot = []
h_lsplot = []
p_s1plot = []
p_d1plot = []
w_c1plot = []
p_s2plot = []
p_d2plot = []
w_c2plot = []
p_s3plot = []
p_d3plot = []
w_c3plot = []
m_glplot = []
#u-value containers
u_gl1plot = []
u_gl2plot = []
u_gl3plot = []
u_gl4plot = []
u_gl5plot = []
u_gl6plot = []
z_ovplot = []
u_1plot = []
u_2plot = []
u_3plot = []
u_4plot = []
u_rec1plot = []
u_rec2plot = []
u_rec3plot = []
u_pc1plot = []
u_pc2plot = []
u_pc3plot = []
u_pc4plot = []
u_pc5plot = []
u_pc6plot = []
#z-calue containers
p_ai1plot = []
p_ai2plot = []
p_ai3plot = []
p_ai4plot = []
p_ai5plot = []
p_ai6plot = []
p_wh1plot = []
p_wh2plot = []
p_wh3plot = []
p_wh4plot = []
p_wh5plot = []
p_wh6plot = []
p_wi1plot = []
p_wi2plot = []
p_wi3plot = []
p_wi4plot = []
p_wi5plot = []
p_wi6plot = []
p_bh1plot = []
p_bh2plot = []
p_bh3plot = []
p_bh4plot = []
p_bh5plot = []
p_bh6plot = []
rho_ai1plot = []
rho_ai2plot = []
rho_ai3plot = []
rho_ai4plot = []
rho_ai5plot = []
rho_ai6plot = []
rho_m1plot = []
rho_m2plot = []
rho_m3plot = []
rho_m4plot = []
rho_m5plot = []
rho_m6plot = []
w_iv1plot = []
w_iv2plot = []
w_iv3plot = []
w_iv4plot = []
w_iv5plot = []
w_iv6plot = []
w_pc1plot = []
w_pc2plot = []
w_pc3plot = []
w_pc4plot = []
w_pc5plot = []
w_pc6plot = []
w_pg1plot = []
w_pg2plot = []
w_pg3plot = []
w_pg4plot = []
w_pg5plot = []
w_pg6plot = []
w_po1plot = []
w_po2plot = []
w_po3plot = []
w_po4plot = []
w_po5plot = []
w_po6plot = []
w_ro1plot = []
w_ro2plot = []
w_ro3plot = []
w_ro4plot = []
w_ro5plot = []
w_ro6plot = []
w_rg1plot = []
w_rg2plot = []
w_rg3plot = []
w_rg4plot = []
w_rg5plot = []
w_rg6plot = []
p_rhplot = []
rho_rplot = []
p_mplot = []
w_prplot = []
w_toplot = []
w_tgplot = []
w_osplot = []
w_gsplot = []
rho_gsplot = []
p_osplot = []
v_osplot = []
v_gsplot = []
w_in1plot = []
w_out1plot = []
rho_in1plot = []
rho_d1plot = []
Phi1plot = []
Pow1plot = []
y_p1plot = []
n_p1plot = []
Phi_max1plot = []
gamma_2_dummy1plot = []
w_rec1plot = []
w_in2plot = []
w_out2plot = []
rho_in2plot = []
rho_d2plot = []
Phi2plot = []
Pow2plot = []
y_p2plot = []
n_p2plot = []
Phi_max2plot = []
gamma_2_dummy2plot = []
w_rec2plot = []
w_in3plot = []
w_out3plot = []
rho_in3plot = []
rho_d3plot = []
Phi3plot = []
Pow3plot = []
y_p3plot = []
n_p3plot = []
Phi_max3plot = []
gamma_2_dummy3plot = []
w_rec3plot = []
w_gl1plot = []
w_gl2plot = []
w_gl3plot = []
w_gl4plot = []
w_gl5plot = []
w_gl6plot = []
p_outplot = []
rho_outplot = []



#Define time span of simulation
t_span = np.arange(10000)

#Initialize initial values
uk = u0
xf = x0
zk = z0

#Make containers for storing integrator/control output
x_store =[]
z_store = []
u_store = []
p_store = []
error_store = [0]
B = []

################### Integrator ###################

for k in t_span:
    #Change to simulate disturbance in GOR(Possible to implement disturbance in more variables)
    #if k == 2000:
        #p0[0] -= 0.1
        #p0[1] += 0.1
        #p0[2] += 0.1
        #p0[3] += 0.1
        #p0[4] += 0.1
        #p0[5] += 0.1
    
    #Simulate step change in the gas lift valves(u_gl)
    #if k == 1000:
        #uk[0] += 0.2
        #uk[1] += 0.1
        #uk[2] += 0.4
        #uk[3] += 0.2
        #uk[4] += 0.2
        #uk[5] += 0.2
        
    #Solving the initial value problem 
    inputs = ca.vertcat(uk, p0)
    Fk = F(x0 = xf, z0 = zk, p = inputs) 
    #Retrieving the differential states
    xf = (Fk['xf']).full()
    #Retrieving the algebraic states
    zk = (Fk['zf']).full()
    
    #Append results
    x_store.append(xf)
    u_store.append(uk)
    
    #PID controller, tuned with SIMC rules(integration process)
    h = x_store[k][21] #Value of height og oil at current iteration
    h_sp = 1.65716 #Optimal height, thus used as setpoint
    tauC = 50 #Controller time, can be changed up or down depending on needs for fast control or smooth control 
    tauI = 4*tauC #Integral time, corresponding to SIMC rules for integration processes.
    Kp1 = 1/(5.1732222222222735e-06*tauC)#Proportional gain
    Ki1 = Kp1/tauI #Integral gain
    error = (h_sp - h) #Difference between setpoint and measured height
    #Calculate new controller output
    u = ca.fmax(0, ca.fmin(1, (u_store[k-1][6] - (Kp1*error + Ki1*error - Kp1*error_store[k-1] )))) 
    #Update the controller output for z_ov(oil valve separator)
    uk[6] = u
    #Store all errors, to be used for previous errors
    error_store.append(error) 
    
    ################################
    #appending the resulting x values from the integration
    ################################

    
    m_ga1plot.append(xf[0])
    m_ga2plot.append(xf[1])
    m_ga3plot.append(xf[2])
    m_ga4plot.append(xf[3])
    m_ga5plot.append(xf[4])
    m_ga6plot.append(xf[5])
    m_gt1plot.append(xf[6])
    m_gt2plot.append(xf[7])
    m_gt3plot.append(xf[8])
    m_gt4plot.append(xf[9])
    m_gt5plot.append(xf[10])
    m_gt6plot.append(xf[11])
    m_ot1plot.append(xf[12])
    m_ot2plot.append(xf[13])
    m_ot3plot.append(xf[14])
    m_ot4plot.append(xf[15])
    m_ot5plot.append(xf[16])
    m_ot6plot.append(xf[17])
    m_grplot.append(xf[18])
    m_orplot.append(xf[19])
    p_gsplot.append(xf[20])
    h_lsplot.append(xf[21])
    p_s1plot.append(xf[22])
    p_d1plot.append(xf[23])
    w_c1plot.append(xf[24])
    p_s2plot.append(xf[25])
    p_d2plot.append(xf[26])
    w_c2plot.append(xf[27])
    p_s3plot.append(xf[28])
    p_d3plot.append(xf[29])
    w_c3plot.append(xf[30])
    m_glplot.append(xf[31])

    ################################
    #appending u-values
    ################################
    u_gl1plot.append(uk[0])
    u_gl2plot.append(uk[1])
    u_gl3plot.append(uk[2])
    u_gl4plot.append(uk[3])
    u_gl5plot.append(uk[4])
    u_gl6plot.append(uk[5])
    z_ovplot.append(uk[6])
    u_1plot.append(uk[7]) 
    u_2plot.append(uk[14])
    u_3plot.append(uk[15])  
    u_4plot.append(uk[16])
    u_rec1plot.append(uk[17]) 
    u_rec2plot.append(uk[18]) 
    u_rec3plot.append(uk[19]) 
    u_pc1plot.append(uk[8]) 
    u_pc2plot.append(uk[9]) 
    u_pc3plot.append(uk[10]) 
    u_pc4plot.append(uk[11]) 
    u_pc5plot.append(uk[12]) 
    u_pc6plot.append(uk[13]) 
    ###############################
    #appending z-values
    ###############################

    p_ai1plot.append(zk[0]) 
    p_ai2plot.append(zk[1]) 
    p_ai3plot.append(zk[2])  
    p_ai4plot.append(zk[3])  
    p_ai5plot.append(zk[4])  
    p_ai6plot.append(zk[5])  
    p_wh1plot.append(zk[6])  
    p_wh2plot.append(zk[7])  
    p_wh3plot.append(zk[8])  
    p_wh4plot.append(zk[9])  
    p_wh5plot.append(zk[10])  
    p_wh6plot.append(zk[11])  
    p_wi1plot.append(zk[12])  
    p_wi2plot.append(zk[13])  
    p_wi3plot.append(zk[14])  
    p_wi4plot.append(zk[15])  
    p_wi5plot.append(zk[16])  
    p_wi6plot.append(zk[17])  
    p_bh1plot.append(zk[18])  
    p_bh2plot.append(zk[19])  
    p_bh3plot.append(zk[20])  
    p_bh4plot.append(zk[21])  
    p_bh5plot.append(zk[22])  
    p_bh6plot.append(zk[23])  
    rho_ai1plot.append(zk[24])  
    rho_ai2plot.append(zk[25])  
    rho_ai3plot.append(zk[26])  
    rho_ai4plot.append(zk[27])  
    rho_ai5plot.append(zk[28])  
    rho_ai6plot.append(zk[29])  
    rho_m1plot.append(zk[30])  
    rho_m2plot.append(zk[31])  
    rho_m3plot.append(zk[32])  
    rho_m4plot.append(zk[33])  
    rho_m5plot.append(zk[34])  
    rho_m6plot.append(zk[35])  
    w_iv1plot.append(zk[36])  
    w_iv2plot.append(zk[37])  
    w_iv3plot.append(zk[38])  
    w_iv4plot.append(zk[39])  
    w_iv5plot.append(zk[40])  
    w_iv6plot.append(zk[41])  
    w_pc1plot.append(zk[42])  
    w_pc2plot.append(zk[43])  
    w_pc3plot.append(zk[44])  
    w_pc4plot.append(zk[45])  
    w_pc5plot.append(zk[46])  
    w_pc6plot.append(zk[47])  
    w_pg1plot.append(zk[48])  
    w_pg2plot.append(zk[49])  
    w_pg3plot.append(zk[50])  
    w_pg4plot.append(zk[51])  
    w_pg5plot.append(zk[52])  
    w_pg6plot.append(zk[53])  
    w_po1plot.append(zk[54])  
    w_po2plot.append(zk[55])  
    w_po3plot.append(zk[56])  
    w_po4plot.append(zk[57])  
    w_po5plot.append(zk[58])  
    w_po6plot.append(zk[59])  
    w_ro1plot.append(zk[60])  
    w_ro2plot.append(zk[61])  
    w_ro3plot.append(zk[62])  
    w_ro4plot.append(zk[63])  
    w_ro5plot.append(zk[64])  
    w_ro6plot.append(zk[65])  
    w_rg1plot.append(zk[66])  
    w_rg2plot.append(zk[67])  
    w_rg3plot.append(zk[68])  
    w_rg4plot.append(zk[69])  
    w_rg5plot.append(zk[70])  
    w_rg6plot.append(zk[71])  
    p_rhplot.append(zk[72])  
    rho_rplot.append(zk[73])  
    p_mplot.append(zk[74])  
    w_prplot.append(zk[75])  
    w_toplot.append(zk[76])  
    w_tgplot.append(zk[77])  
    w_osplot.append(zk[78])  
    w_gsplot.append(zk[79])  
    rho_gsplot.append(zk[80])  
    p_osplot.append(zk[81])  
    v_osplot.append(zk[82])  
    v_gsplot.append(zk[83])  
    w_in1plot.append(zk[84])  
    w_out1plot.append(zk[85])  
    rho_in1plot.append(zk[86])  
    rho_d1plot.append(zk[87])  
    Phi1plot.append(zk[88])  
    Pow1plot.append(zk[89])  
    y_p1plot.append(zk[90])  
    n_p1plot.append(zk[91])  
    Phi_max1plot.append(zk[92]) 
    gamma_2_dummy1plot.append(zk[93])  
    w_rec1plot.append(zk[94])  
    w_in2plot.append(zk[95])  
    w_out2plot.append(zk[96])  
    rho_in2plot.append(zk[97])  
    rho_d2plot.append(zk[98])  
    Phi2plot.append(zk[99])  
    Pow2plot.append(zk[100])  
    y_p2plot.append(zk[101])  
    n_p2plot.append(zk[102])  
    Phi_max2plot.append(zk[103])  
    gamma_2_dummy2plot.append(zk[104])  
    w_rec2plot.append(zk[105])  
    w_in3plot.append(zk[106])  
    w_out3plot.append(zk[107])  
    rho_in3plot.append(zk[108])  
    rho_d3plot.append(zk[109])  
    Phi3plot.append(zk[110])  
    Pow3plot.append(zk[111])  
    y_p3plot.append(zk[112])  
    n_p3plot.append(zk[113])  
    Phi_max3plot.append(zk[114])  
    gamma_2_dummy3plot.append(zk[115])  
    w_rec3plot.append(zk[116])  
    w_gl1plot.append(zk[117])  
    w_gl2plot.append(zk[118])  
    w_gl3plot.append(zk[119])  
    w_gl4plot.append(zk[120])  
    w_gl5plot.append(zk[121])  
    w_gl6plot.append(zk[122])  
    p_outplot.append(zk[123])  
    rho_outplot.append(zk[124])  
    B.append(-zk[78] + zk[89] + zk[100] + zk[111])


import matplotlib.pyplot as plt
plt.rcParams['axes.grid'] = True
t = t_span
fig1, axs1 = plt.subplots(24, 2, figsize=(15,40))  
fig1.tight_layout(pad=5.0)



axs1[0,0].plot(t,m_ga1plot)
axs1[0,0].plot(t,m_ga2plot)
axs1[0,0].plot(t,m_ga3plot)
axs1[0,0].plot(t,m_ga4plot)
axs1[0,0].plot(t,m_ga5plot)
axs1[0,0].plot(t,m_ga6plot)
axs1[0,0].set_title('Mass gas in annulus(m_ga)[ton] vs time\n')
axs1[0,0].set_xlabel('ton')

axs1[0,1].plot(t,m_gt1plot)
axs1[0,1].plot(t,m_gt2plot)
axs1[0,1].plot(t,m_gt3plot)
axs1[0,1].plot(t,m_gt4plot)
axs1[0,1].plot(t,m_gt5plot)
axs1[0,1].plot(t,m_gt6plot)
axs1[0,1].set_title('Mass gas in tubing(m_gt)[ton] vs time\n')

axs1[1,0].plot(t,m_ot1plot)
axs1[1,0].plot(t,m_ot2plot)
axs1[1,0].plot(t,m_ot3plot)
axs1[1,0].plot(t,m_ot4plot)
axs1[1,0].plot(t,m_ot5plot)
axs1[1,0].plot(t,m_ot6plot)
axs1[1,0].set_title('Mass oil in tubing(m_ot)[ton] vs time\n')

axs1[1,1].plot(t,m_grplot)
axs1[1,1].set_title('Mass gas in riser(m_gr)[ton] vs time\n')

axs1[2,0].plot(t,m_orplot)
axs1[2,0].set_title('Mass oil in riser(m_or)[ton] vs time\n')

axs1[2,1].plot(t,p_gsplot)
axs1[2,1].set_title('Pressure gas in separator(p_gs)[bar] vs time\n')


axs1[3,0].plot(t,h_lsplot)
axs1[3,0].set_title('Height oil in separator(h_ls)[m] vs time\n')


axs1[3,1].plot(t,p_s1plot)
axs1[3,1].plot(t,p_s2plot)
axs1[3,1].plot(t,p_s3plot)
axs1[3,1].set_title('Suction pressure compressors(p_s)[bar] vs time\n')


axs1[4,0].plot(t,p_d1plot)
axs1[4,0].plot(t,p_d2plot)
axs1[4,0].plot(t,p_d3plot)
axs1[4,0].set_title('Discharge pressure compressors(p_d)[bar] vs time\n')

axs1[4,1].plot(t,w_c1plot)
axs1[4,1].plot(t,w_c2plot)
axs1[4,1].plot(t,w_c3plot)
axs1[4,1].set_title('Mass compressors(m_c)[kg] vs time\n')


axs1[5,0].plot(t,m_glplot)
axs1[5,0].set_title('Mas gas in gas-lift Line(m_gl)[ton] vs time\n')

#z values
axs1[5,1].plot(t,p_ai1plot)
axs1[5,1].plot(t,p_ai2plot)
axs1[5,1].plot(t,p_ai3plot)
axs1[5,1].plot(t,p_ai4plot)
axs1[5,1].plot(t,p_ai5plot)
axs1[5,1].plot(t,p_ai6plot)
axs1[5,1].set_title('Annulus pressure injection(p_ai)[bar] vs time\n')


axs1[6,0].plot(t,p_wh1plot)
axs1[6,0].plot(t,p_wh2plot)
axs1[6,0].plot(t,p_wh3plot)
axs1[6,0].plot(t,p_wh4plot)
axs1[6,0].plot(t,p_wh5plot)
axs1[6,0].plot(t,p_wh6plot)
axs1[6,0].set_title('Wellhead pressure(p_wh)[bar] vs time\n')

axs1[6,1].plot(t,p_wi1plot)
axs1[6,1].plot(t,p_wi2plot)
axs1[6,1].plot(t,p_wi3plot)
axs1[6,1].plot(t,p_wi4plot)
axs1[6,1].plot(t,p_wi5plot)
axs1[6,1].plot(t,p_wi6plot)
axs1[6,1].set_title('Injection Point pressure(p_wi)[bar] vs time\n')

axs1[7,0].plot(t,p_bh1plot)
axs1[7,0].plot(t,p_bh2plot)
axs1[7,0].plot(t,p_bh3plot)
axs1[7,0].plot(t,p_bh4plot)
axs1[7,0].plot(t,p_bh5plot)
axs1[7,0].plot(t,p_bh6plot)
axs1[7,0].set_title('Bottom hole pressure(p_bh)[bar] vs time\n')

axs1[7,1].plot(t,rho_ai1plot)
axs1[7,1].plot(t,rho_ai2plot)
axs1[7,1].plot(t,rho_ai3plot)
axs1[7,1].plot(t,rho_ai4plot)
axs1[7,1].plot(t,rho_ai5plot)
axs1[7,1].plot(t,rho_ai6plot)
axs1[7,1].set_title('Density gas annulus(rho_ai)[kg*10^(-2)/m3] vs time\n')

axs1[8,0].plot(t,rho_m1plot)
axs1[8,0].plot(t,rho_m2plot)
axs1[8,0].plot(t,rho_m3plot)
axs1[8,0].plot(t,rho_m4plot)
axs1[8,0].plot(t,rho_m5plot)
axs1[8,0].plot(t,rho_m6plot)
axs1[8,0].set_title('Density gas/oil tubing(rho_m)[kg*10^(-2)/m3] vs time\n')

axs1[8,1].plot(t,w_iv1plot)
axs1[8,1].plot(t,w_iv2plot)
axs1[8,1].plot(t,w_iv3plot)
axs1[8,1].plot(t,w_iv4plot)
axs1[8,1].plot(t,w_iv5plot)
axs1[8,1].plot(t,w_iv6plot)
axs1[8,1].set_title('Massflow injection valve(w_iv)[kg/s] vs time\n')

axs1[9,0].plot(t,w_pc1plot)
axs1[9,0].plot(t,w_pc2plot)
axs1[9,0].plot(t,w_pc3plot)
axs1[9,0].plot(t,w_pc4plot)
axs1[9,0].plot(t,w_pc5plot)
axs1[9,0].plot(t,w_pc6plot)
axs1[9,0].set_title('Massflow production valve(w_pc)[kg/s] vs time\n')

axs1[9,1].plot(t,w_pg1plot)
axs1[9,1].plot(t,w_pg2plot)
axs1[9,1].plot(t,w_pg3plot)
axs1[9,1].plot(t,w_pg4plot)
axs1[9,1].plot(t,w_pg5plot)
axs1[9,1].plot(t,w_pg6plot)
axs1[9,1].set_title('Massflow gas production choke(w_pg)[kg/s] vs time\n')

axs1[10,0].plot(t,w_po1plot)
axs1[10,0].plot(t,w_po2plot)
axs1[10,0].plot(t,w_po3plot)
axs1[10,0].plot(t,w_po4plot)
axs1[10,0].plot(t,w_po5plot)
axs1[10,0].plot(t,w_po6plot)
axs1[10,0].set_title('Massflow oil production choke(w_po)[kg/s] vs time\n')

axs1[10,1].plot(t,w_ro1plot)
axs1[10,1].plot(t,w_ro2plot)
axs1[10,1].plot(t,w_ro3plot)
axs1[10,1].plot(t,w_ro4plot)
axs1[10,1].plot(t,w_ro5plot)
axs1[10,1].plot(t,w_ro6plot)
axs1[10,1].set_title('Massflow reservoir oil(w_ro)[kg/s] vs time\n')

axs1[11,0].plot(t,w_rg1plot)
axs1[11,0].plot(t,w_rg2plot)
axs1[11,0].plot(t,w_rg3plot)
axs1[11,0].plot(t,w_rg4plot)
axs1[11,0].plot(t,w_rg5plot)
axs1[11,0].plot(t,w_rg6plot)
axs1[11,0].set_title('Massflow reservoir gas(w_rg)[kg/s] vs time\n')

axs1[11,1].plot(t,p_rhplot)
axs1[11,1].set_title('Riser head pressure(p_rh)[bar] vs time\n')

axs1[12,0].plot(t,rho_rplot)
axs1[12,0].set_title('Riser density(rho_r)[kg*10^(-2)/m3] vs time\n')

axs1[12,1].plot(t,p_mplot)
axs1[12,1].set_title('Manifold pressure(p_m)[bar] vs time\n')

axs1[13,0].plot(t,w_prplot)
axs1[13,0].set_title('Massflow riser(w_pr)[kg/s] vs time\n')

axs1[13,1].plot(t,w_toplot)
axs1[13,1].set_title('Massflow oil riser(w_to)[kg/s] vs time\n')

axs1[14,0].plot(t,w_tgplot)
axs1[14,0].set_title('Massflow gas riser(w_tg)[kg/s] vs time\n')

#axs1[14,1].plot(t,w_osplot)
#axs1[14,1].set_title('Massflow oil out Sep(w_os)[kg/s] vs time\n')
axs1[14,1].plot(t,B)
axs1[14,1].set_title('Objective function vs time')

axs1[15,0].plot(t,w_gsplot)
axs1[15,0].set_title('Massflow gas out Sep(w_gs)[kg/s] vs time\n')

axs1[15,1].plot(t,rho_gsplot)
axs1[15,1].set_title('Density gas Sep(rho_gs)[kg*10^(-2)/m3] vs time\n')

axs1[16,0].plot(t,p_osplot)
axs1[16,0].set_title('Pressure oil Sep(p_os)[bar] vs time\n')

axs1[16,1].plot(t,v_osplot)
axs1[16,1].set_title('Volume oil Sep(v_os)[bar] vs time \n')

axs1[17,0].plot(t,v_gsplot)
axs1[17,0].set_title('Volume gas Sep(v_gs)[bar] vs time\n')

#Compressor 1
axs1[17,1].plot(t,w_in1plot)
axs1[17,1].plot(t,w_in2plot)
axs1[17,1].plot(t,w_in3plot)
axs1[17,1].set_title('gasflow in Compressors(w_in)[kg/s] vs time\n')


axs1[18,0].plot(t,w_out1plot)
axs1[18,0].plot(t,w_out2plot)
axs1[18,0].plot(t,w_out3plot)
axs1[18,0].set_title('gasflow out Compressors(w_out)[kg/s] vs time\n')

axs1[18,1].plot(t,rho_in1plot)
axs1[18,1].plot(t,rho_in2plot)
axs1[18,1].plot(t,rho_in3plot)
axs1[18,1].set_title('Density in Compressors(rho_in)[kg*10^(-2)/m3]  vs time\n')

axs1[19,0].plot(t,rho_d1plot)
axs1[19,0].plot(t,rho_d2plot)
axs1[19,0].plot(t,rho_d3plot)
axs1[19,0].set_title('Density out Compressors(rho_d)[kg*10^(-2)/m3]  vs time\n')

axs1[19,1].plot(t,Phi1plot)
axs1[19,1].plot(t,Phi2plot)
axs1[19,1].plot(t,Phi3plot)
axs1[19,1].set_title('Pressure ratio Compressors(Phi)[-]s time\n')

axs1[20,0].plot(t,Pow1plot)
axs1[20,0].plot(t,Pow2plot)
axs1[20,0].plot(t,Pow3plot)
axs1[20,0].set_title('Power Compressor(Pow)[kW] vs time\n')

axs1[20,1].plot(t,y_p1plot)
axs1[20,1].plot(t,y_p2plot)
axs1[20,1].plot(t,y_p3plot)
axs1[20,1].set_title('Polytropic head Compressors(y_p)[m] vs time\n')

axs1[21,0].plot(t,n_p1plot)
axs1[21,0].plot(t,n_p2plot)
axs1[21,0].plot(t,n_p3plot)
axs1[21,0].set_title('Polytropic efficiency Compressors(n_p)[%] vs time\n')

axs1[21,1].plot(t,w_rec1plot)
axs1[21,1].plot(t,w_rec2plot)
axs1[21,1].plot(t,w_rec3plot)
axs1[21,1].set_title('Recycle Massflow(w_rec)[kg/s] vs time\n')


axs1[22,0].plot(t,w_gl1plot)
axs1[22,0].plot(t,w_gl2plot)
axs1[22,0].plot(t,w_gl3plot)
axs1[22,0].plot(t,w_gl4plot)
axs1[22,0].plot(t,w_gl5plot)
axs1[22,0].plot(t,w_gl6plot)
axs1[22,0].set_title('Massflow Gas lift(w_gl)[kg/s] vs time\n')

axs1[22,1].plot(t,p_outplot)
axs1[22,1].set_title('Pressure lift gas(p_out)[bar] vs time\n')

axs1[23,0].plot(t,rho_outplot)
axs1[23,0].set_title('Density lift gas(rho_out)[kg*10^(-2)/m3] vs time\n')

axs1[23,1].step(t,z_ovplot)
axs1[23,1].set_title('Level control separator(z_ov) vs time')


"""
#fig1.delaxes(axs1[11,3])


#plt.savefig('FinalIntegrationResults2.png')





################### Optimizer ###################

#Get shape of controlled, and differential states
nu = u_var.shape[0]
nx = x_var.shape[0]

#Define equality constraints of nlp, equals the model equations
eqcon = ca.vertcat(alg, dif) 
x = ca.vertcat(u_var, x_var, z_var)
#Define the optimization problem(x = states, L= objective function, g = inequality constraints, p = parameters)
nlp = {
       'x': ca.vertcat(u_var, x_var, z_var),
       'f': L,
       'g': ca.vertcat(eqcon, g_var),
       'p': p_var,
       }

#Define upper/lower bounds for the inequality constraints
lbg = ca.vertcat(np.full(eqcon.shape, 0), np.full(g_var.shape, -ca.inf))
ubg = ca.vertcat(np.full(eqcon.shape, 0), np.full(g_var.shape, 0))

#Use IPOPT(interior point optimizer) fromt the CasADI framework to solve the nlp
opt_inst = ca.nlpsol('opt_inst', 'ipopt', nlp)

#Extract the solution of the optimization, feed ipopt initial values, lower and upper bounds
opt_res = (opt_inst(p=p0,x0 = ca.vertcat(u0,x0,z0), lbx = ca.vertcat(lbu,lbx,lbz), ubx = ca.vertcat(ubu,ubx,ubz), lbg=lbg, ubg=ubg))

states = opt_res['x'] #Optimal controlled variables(u), differential states(x) and algebraic states(z)
cost = opt_res['f'] #Value of objective function at optimal point
print(states)
